; NOTE: If you want to modify this code, you should reassemble it with SPASM.
; Other assemblers will not understand the macros that make dealing with funky
; Axe limitations easier.
.nolist

#include "ti83plus.inc"
#include "Axe.inc"
#include "TokenHook.inc"

#macro RESET_REORG_USAGE_COUNTER
	#ifndef USAGE_COUNTER
		.echo "REORG macros initalized."
		#define USAGE_COUNTER 0
	#else
		.echo "Previous REORG offset: ", USAGE_COUNTER
		#undefine USAGE_COUNTER
		#define USAGE_COUNTER 0
	#endif
#endmacro
#macro INCREMENT_USAGE_COUNTER
	#define NEW_USAGE_COUNTER eval(USAGE_COUNTER+1)
	#undefine USAGE_COUNTER
	#define USAGE_COUNTER eval(NEW_USAGE_COUNTER)
	#undefine NEW_USAGE_COUNTER
#endmacro
#macro REPLACE_NEXT
	.db $7F
	.org $-1
	INCREMENT_USAGE_COUNTER
#endmacro
#macro ABSOLUTE_NEXT
	.db $49
	.org $-1
	INCREMENT_USAGE_COUNTER
#endmacro
#ifdef b_jump
	#undefine b_jump
#endif
#macro b_jump(xxxx)
	ABSOLUTE_NEXT
	call 50h
	.dw xxxx
#endmacro

;#define DEBUG

#ifdef DEBUG
	#define BREAK or a \ jr nc, $
	#macro DISPHL
		push	af
		push	bc
		push	de
		push	hl
		b_call(_DispHL)
		b_call(_NewLine)
		pop	hl
		pop	de
		pop	bc
		pop	af
	#endmacro
	#macro DISPDE
		push	af
		push	bc
		push	de
		push	hl
		ex	de, hl
		b_call(_DispHL)
		b_call(_NewLine)
		pop	hl
		pop	de
		pop	bc
		pop	af
	#endmacro
	#macro DISPBC
		push	af
		push	bc
		push	de
		push	hl
		ld	l, c
		ld	h, b
		b_call(_DispHL)
		b_call(_NewLine)
		pop	hl
		pop	de
		pop	bc
		pop	af
	#endmacro
	#macro DispChar(x)
		push	af
		ld	a, x
		b_call(_PutC)
		pop	af
	#endmacro
#else
	#define BREAK .echo "Nope, no breakpoints."
	#define DISPHL .echo "Skipped DISPHL."
	#define DISPDE .echo "Skipped DISPDE."
	#define DISPBC .echo "Skipped DISPBC."
	#define DispChar(x) .echo "Skipped DispChar(", x, ")"
#endif
.list


;====== Equates ================================================================



;====== Header =================================================================

	.dw	AXM_HEADER


;====== Routine 1: Detokenize( =================================================
; Detokenize(StrPtr,OutPtr,OutBufSize)
; This is not optimized.
; 
; Local Variables
endAddr		.equ	2
readPtr		.equ	4
dataLeft	.equ	6
writePtr	.equ	8

	.dw	routine1Size
	.db	AXM_ALL
	.db	t2ByteTok, tStrngToEqu
	.db	AXM_SUB
	.db	AXM_3ARGS
	.org	0
	RESET_REORG_USAGE_COUNTER

	; Stack shuffle
	pop	ix	; ret address
	pop	de
	pop	bc
	push	ix	; save
	ld	ix, 0
	add	ix, sp	; get RAM for local vars
	add	hl, de
	push	hl	; Var -1: End address of buffer
	push	bc	; Var -3: Current read ptr
	dec	bc
	ld	a, (bc)
	ld	h, a
	dec	bc
	ld	a, (bc)
	ld	l, a
	push	hl	; Var -5: Number of bytes of input remaining
	ld	a, l
	or	h
	jr	z, endDetok
	push	de	; Var -7: Current write ptr
detokenizeLoop:
	; Get token
	ld	l, (ix-readPtr)
	ld	h, (ix-readPtr+1)
	b_call(_Get_Tok_Strng)
	; Is there room for the string?
	ld	l, (ix-writePtr)
	ld	h, (ix-writePtr+1)
	push	hl
	add	hl, bc
	ld	e, (ix-endAddr)
	ld	d, (ix-endAddr+1)
	xor	a
	sbc	hl, de
;	cp	h
	pop	de
	jr	nc, endDetok
	; Copy string to output
	ld	hl, OP3
	ldir
;	xor	a
	ld	(de), a
	; Save write pointer
	ld	(ix-writePtr), e
	ld	(ix-writePtr+1), d
	; Update pointers
	ld	l, (ix-readPtr)
	ld	h, (ix-readPtr+1)
	ld	a, (hl)
	b_call(_IsA2ByteTok)
	ld	e, (ix-dataLeft)
	ld	d, (ix-dataLeft+1)
	jr	nz, +_
	inc	hl
	dec	de
_:	inc	hl
	dec	de
	ld	(ix-dataLeft), e
	ld	(ix-dataLeft+1), d
	ld	(ix-readPtr), l
	ld	(ix-readPtr+1), h
	; Is there any more data?
	ld	a, e
	or	d
	jr	nz, detokenizeLoop
endDetok:
	ld	sp, ix
	ret

routine1Size = $ + USAGE_COUNTER
.echo "routine1size: ", routine1Size


;====== Routine 2: CleanAll ====================================================

	.dw	routine2Size
	.db	AXM_ALL
	.db	t2ByteTok, tClrAllLst
	.db	AXM_INLINE
	.db	AXM_0ARGS
	.org	0
	RESET_REORG_USAGE_COUNTER

	b_call(_CleanAll)

routine2Size = $ + USAGE_COUNTER
.echo "routine2size: ", routine2Size


;====== Routine 3: Get_Tok_Strng ===============================================

	.dw	routine3Size
	.db	AXM_ALL
	.db	t2ByteTok, tFPDF
	.db	AXM_SUB
	.db	AXM_1ARG
	.org	0
	RESET_REORG_USAGE_COUNTER

	b_call(_Get_Tok_Strng)
	ld	l, c
	ld	h, b
	ret

routine3Size = $ + USAGE_COUNTER
.echo "routine3size: ", routine3Size


;====== Routine 4: IsA2ByteTok =================================================

	.dw	routine4Size
	.db	AXM_ALL
	.db	t2ByteTok, tDF ; No, I don't know why.
	.db	AXM_SUB
	.db	AXM_1ARG
	.org	0
	RESET_REORG_USAGE_COUNTER

	ld	a, l
	b_call(_IsA2ByteTok)
	ld	hl, 0
	ret	z
	inc	hl
	ret
	

routine4Size = $ + USAGE_COUNTER
.echo "routine4size: ", routine4Size


;====== Tokens =================================================================

	.dw	AXM_END

	.dw	hStrngToEqu
_:	.db	+_--_-1
	.db	"Detokenize("
_:
	.dw	hClrAllLst
_:	.db	+_--_-1
	.db	"CleanAll()"
_:
	.dw	hFPDF
_:	.db	+_--_-1
	.db	"Get_Tok_Strng("
_:
	.dw	hDF
_:	.db	+_--_-1
	.db	"IsA2ByteTok("
_:
